<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="科目名称" prop="subjectName">
        <el-input
                v-model="queryParams.subjectName"
                placeholder="请输入科目名称"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
<!--      <el-form-item label="拼音" prop="pinyin">-->
<!--        <el-input-->
<!--                v-model="queryParams.pinyin"-->
<!--                placeholder="请输入拼音"-->
<!--                clearable-->
<!--                @keyup.enter="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item label="排序" prop="sort">-->
<!--        <el-input-->
<!--                v-model="queryParams.sort"-->
<!--                placeholder="请输入排序"-->
<!--                clearable-->
<!--                @keyup.enter="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="适合省份" prop="locations">
        <el-input
                v-model="queryParams.locations"
                placeholder="请输入适合省份"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="适合类别" prop="examTypes">
        <el-select v-model="queryParams.examTypes" placeholder="请选择适合类别" clearable style="width: 170px;">
          <el-option
                  v-for="dict in exam_type"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
                type="primary"
                plain
                icon="Plus"
                @click="handleAdd"
                v-hasPermi="['dz:subject:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="success"
                plain
                icon="Edit"
                :disabled="single"
                @click="handleUpdate"
                v-hasPermi="['dz:subject:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="danger"
                plain
                icon="Delete"
                :disabled="multiple"
                @click="handleDelete"
                v-hasPermi="['dz:subject:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="warning"
                plain
                icon="Download"
                @click="handleExport"
                v-hasPermi="['dz:subject:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="subjectList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="科目ID" align="center" prop="subjectId" />
      <el-table-column label="科目名称" align="center" prop="subjectName" />
      <el-table-column label="拼音" align="center" prop="pinyin" />
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="适合省份" align="center" prop="locations" />
      <el-table-column label="适合类别" align="center" prop="examTypes">
        <template #default="scope">
          <dict-tag :options="exam_type" :value="scope.row.examTypes"/>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['dz:subject:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['dz:subject:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
            v-show="total>0"
            :total="total"
            v-model:page="queryParams.pageNum"
            v-model:limit="queryParams.pageSize"
            @pagination="getList"
    />

    <!-- 添加或修改科目对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="subjectRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="科目名称" prop="subjectName">
          <el-input v-model="form.subjectName" placeholder="请输入科目名称" />
        </el-form-item>
        <el-form-item label="拼音" prop="pinyin">
          <el-input v-model="form.pinyin" placeholder="请输入拼音" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="适合省份" prop="locations">
          <el-input v-model="form.locations" placeholder="请输入适合省份" />
        </el-form-item>
        <el-form-item label="适合类别" prop="examTypes">
          <el-select v-model="form.examTypes" placeholder="请选择适合类别">
            <el-option
                    v-for="dict in exam_type"
                    :key="dict.value"
                    :label="dict.label"
                    :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Subject">
  import { listSubject, getSubject, delSubject, addSubject, updateSubject } from "@/api/dz/subject"

  const { proxy } = getCurrentInstance()
  const { exam_type } = proxy.useDict('exam_type')

  const subjectList = ref([])
  const open = ref(false)
  const loading = ref(true)
  const showSearch = ref(true)
  const ids = ref([])
  const single = ref(true)
  const multiple = ref(true)
  const total = ref(0)
  const title = ref("")

  const data = reactive({
    form: {},
    queryParams: {
      pageNum: 1,
      pageSize: 10,
      subjectName: null,
      pinyin: null,
      sort: null,
      locations: null,
      examTypes: null
    },
    rules: {
    }
  })

  const { queryParams, form, rules } = toRefs(data)

  /** 查询科目列表 */
  function getList() {
    loading.value = true
    listSubject(queryParams.value).then(response => {
      subjectList.value = response.rows
      total.value = response.total
      loading.value = false
    })
  }

  // 取消按钮
  function cancel() {
    open.value = false
    reset()
  }

  // 表单重置
  function reset() {
    form.value = {
      subjectId: null,
      subjectName: null,
      pinyin: null,
      sort: null,
      locations: null,
      examTypes: null
    }
    proxy.resetForm("subjectRef")
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1
    getList()
  }

  /** 重置按钮操作 */
  function resetQuery() {
    proxy.resetForm("queryRef")
    handleQuery()
  }

  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.subjectId)
    single.value = selection.length != 1
    multiple.value = !selection.length
  }

  /** 新增按钮操作 */
  function handleAdd() {
    reset()
    open.value = true
    title.value = "添加科目"
  }

  /** 修改按钮操作 */
  function handleUpdate(row) {
    reset()
    const _subjectId = row.subjectId || ids.value
    getSubject(_subjectId).then(response => {
      form.value = response.data
      open.value = true
      title.value = "修改科目"
    })
  }

  /** 提交按钮 */
  function submitForm() {
    proxy.$refs["subjectRef"].validate(valid => {
      if (valid) {
        if (form.value.subjectId != null) {
          updateSubject(form.value).then(response => {
            proxy.$modal.msgSuccess("修改成功")
            open.value = false
            getList()
          })
        } else {
          addSubject(form.value).then(response => {
            proxy.$modal.msgSuccess("新增成功")
            open.value = false
            getList()
          })
        }
      }
    })
  }

  /** 删除按钮操作 */
  function handleDelete(row) {
    const _subjectIds = row.subjectId || ids.value
    proxy.$modal.confirm('是否确认删除科目编号为"' + _subjectIds + '"的数据项？').then(function() {
      return delSubject(_subjectIds)
    }).then(() => {
      getList()
      proxy.$modal.msgSuccess("删除成功")
    }).catch(() => {})
  }

  /** 导出按钮操作 */
  function handleExport() {
    proxy.download('dz/subject/export', {
      ...queryParams.value
    }, `subject_${new Date().getTime()}.xlsx`)
  }

  getList()
</script>
